RFC4511 = {'Lightweight-Directory-Access-Protocol-V3': {'extensibility-implied': True,
                                              'imports': {},
                                              'object-classes': {},
                                              'object-sets': {},
                                              'tags': 'IMPLICIT',
                                              'types': {'AbandonRequest': {'tag': {'class': 'APPLICATION',
                                                                                   'number': 16},
                                                                           'type': 'MessageID'},
                                                        'AddRequest': {'members': [{'name': 'entry',
                                                                                    'optional': False,
                                                                                    'type': 'LDAPDN'},
                                                                                   {'name': 'attributes',
                                                                                    'optional': False,
                                                                                    'type': 'AttributeList'}],
                                                                       'tag': {'class': 'APPLICATION',
                                                                               'number': 8},
                                                                       'type': 'SEQUENCE'},
                                                        'AddResponse': {'tag': {'class': 'APPLICATION',
                                                                                'number': 9},
                                                                        'type': 'LDAPResult'},
                                                        'AssertionValue': {'size': None,
                                                                           'type': 'OCTET STRING'},
                                                        'Attribute': {'type': 'PartialAttribute'},
                                                        'AttributeDescription': {'type': 'LDAPString'},
                                                        'AttributeList': {'element': {'type': 'Attribute'},
                                                                          'size': None,
                                                                          'type': 'SEQUENCE OF'},
                                                        'AttributeSelection': {'element': {'type': 'LDAPString'},
                                                                               'size': None,
                                                                               'type': 'SEQUENCE OF'},
                                                        'AttributeValue': {'size': None,
                                                                           'type': 'OCTET STRING'},
                                                        'AttributeValueAssertion': {'members': [{'name': 'attributeDesc',
                                                                                                 'optional': False,
                                                                                                 'type': 'AttributeDescription'},
                                                                                                {'name': 'assertionValue',
                                                                                                 'optional': False,
                                                                                                 'type': 'AssertionValue'}],
                                                                                    'type': 'SEQUENCE'},
                                                        'AuthenticationChoice': {'members': [{'name': 'simple',
                                                                                              'optional': False,
                                                                                              'size': None,
                                                                                              'tag': {'number': 0},
                                                                                              'type': 'OCTET STRING'},
                                                                                             {'name': 'sasl',
                                                                                              'optional': False,
                                                                                              'tag': {'number': 3},
                                                                                              'type': 'SaslCredentials'},
                                                                                             {'name': '...',
                                                                                              'optional': False,
                                                                                              'type': ''}],
                                                                                 'type': 'CHOICE'},
                                                        'BindRequest': {'members': [{'name': 'version',
                                                                                     'optional': False,
                                                                                     'restricted-to': [(1,
                                                                                                        127)],
                                                                                     'type': 'INTEGER'},
                                                                                    {'name': 'name',
                                                                                     'optional': False,
                                                                                     'type': 'LDAPDN'},
                                                                                    {'name': 'authentication',
                                                                                     'optional': False,
                                                                                     'type': 'AuthenticationChoice'}],
                                                                        'tag': {'class': 'APPLICATION',
                                                                                'number': 0},
                                                                        'type': 'SEQUENCE'},
                                                        'BindResponse': {'members': [{'name': 'serverSaslCreds',
                                                                                      'optional': True,
                                                                                      'size': None,
                                                                                      'tag': {'number': 7},
                                                                                      'type': 'OCTET STRING'}],
                                                                         'tag': {'class': 'APPLICATION',
                                                                                 'number': 1},
                                                                         'type': 'SEQUENCE'},
                                                        'CompareRequest': {'members': [{'name': 'entry',
                                                                                        'optional': False,
                                                                                        'type': 'LDAPDN'},
                                                                                       {'name': 'ava',
                                                                                        'optional': False,
                                                                                        'type': 'AttributeValueAssertion'}],
                                                                           'tag': {'class': 'APPLICATION',
                                                                                   'number': 14},
                                                                           'type': 'SEQUENCE'},
                                                        'CompareResponse': {'tag': {'class': 'APPLICATION',
                                                                                    'number': 15},
                                                                            'type': 'LDAPResult'},
                                                        'Control': {'members': [{'name': 'controlType',
                                                                                 'optional': False,
                                                                                 'type': 'LDAPOID'},
                                                                                {'default': 'FALSE',
                                                                                 'name': 'criticality',
                                                                                 'optional': False,
                                                                                 'type': 'BOOLEAN'},
                                                                                {'name': 'controlValue',
                                                                                 'optional': True,
                                                                                 'size': None,
                                                                                 'type': 'OCTET STRING'}],
                                                                    'type': 'SEQUENCE'},
                                                        'Controls': {'element': {'type': 'Control'},
                                                                     'size': None,
                                                                     'type': 'SEQUENCE OF'},
                                                        'DelRequest': {'tag': {'class': 'APPLICATION',
                                                                               'number': 10},
                                                                       'type': 'LDAPDN'},
                                                        'DelResponse': {'tag': {'class': 'APPLICATION',
                                                                                'number': 11},
                                                                        'type': 'LDAPResult'},
                                                        'ExtendedRequest': {'members': [{'name': 'requestName',
                                                                                         'optional': False,
                                                                                         'tag': {'number': 0},
                                                                                         'type': 'LDAPOID'},
                                                                                        {'name': 'requestValue',
                                                                                         'optional': True,
                                                                                         'size': None,
                                                                                         'tag': {'number': 1},
                                                                                         'type': 'OCTET STRING'}],
                                                                            'tag': {'class': 'APPLICATION',
                                                                                    'number': 23},
                                                                            'type': 'SEQUENCE'},
                                                        'ExtendedResponse': {'members': [{'name': 'responseName',
                                                                                          'optional': True,
                                                                                          'tag': {'number': 10},
                                                                                          'type': 'LDAPOID'},
                                                                                         {'name': 'responseValue',
                                                                                          'optional': True,
                                                                                          'size': None,
                                                                                          'tag': {'number': 11},
                                                                                          'type': 'OCTET STRING'}],
                                                                             'tag': {'class': 'APPLICATION',
                                                                                     'number': 24},
                                                                             'type': 'SEQUENCE'},
                                                        'Filter': {'members': [{'element': {'type': 'Filter'},
                                                                                'name': 'and',
                                                                                'optional': False,
                                                                                'size': [(1,
                                                                                          'MAX')],
                                                                                'tag': {'number': 0},
                                                                                'type': 'SET OF'},
                                                                               {'element': {'type': 'Filter'},
                                                                                'name': 'or',
                                                                                'optional': False,
                                                                                'size': [(1,
                                                                                          'MAX')],
                                                                                'tag': {'number': 1},
                                                                                'type': 'SET OF'},
                                                                               {'name': 'not',
                                                                                'optional': False,
                                                                                'tag': {'number': 2},
                                                                                'type': 'Filter'},
                                                                               {'name': 'equalityMatch',
                                                                                'optional': False,
                                                                                'tag': {'number': 3},
                                                                                'type': 'AttributeValueAssertion'},
                                                                               {'name': 'substrings',
                                                                                'optional': False,
                                                                                'tag': {'number': 4},
                                                                                'type': 'SubstringFilter'},
                                                                               {'name': 'greaterOrEqual',
                                                                                'optional': False,
                                                                                'tag': {'number': 5},
                                                                                'type': 'AttributeValueAssertion'},
                                                                               {'name': 'lessOrEqual',
                                                                                'optional': False,
                                                                                'tag': {'number': 6},
                                                                                'type': 'AttributeValueAssertion'},
                                                                               {'name': 'present',
                                                                                'optional': False,
                                                                                'tag': {'number': 7},
                                                                                'type': 'AttributeDescription'},
                                                                               {'name': 'approxMatch',
                                                                                'optional': False,
                                                                                'tag': {'number': 8},
                                                                                'type': 'AttributeValueAssertion'},
                                                                               {'name': 'extensibleMatch',
                                                                                'optional': False,
                                                                                'tag': {'number': 9},
                                                                                'type': 'MatchingRuleAssertion'},
                                                                               {'name': '...',
                                                                                'optional': False,
                                                                                'type': ''}],
                                                                   'type': 'CHOICE'},
                                                        'IntermediateResponse': {'members': [{'name': 'responseName',
                                                                                              'optional': True,
                                                                                              'tag': {'number': 0},
                                                                                              'type': 'LDAPOID'},
                                                                                             {'name': 'responseValue',
                                                                                              'optional': True,
                                                                                              'size': None,
                                                                                              'tag': {'number': 1},
                                                                                              'type': 'OCTET STRING'}],
                                                                                 'tag': {'class': 'APPLICATION',
                                                                                         'number': 25},
                                                                                 'type': 'SEQUENCE'},
                                                        'LDAPDN': {'type': 'LDAPString'},
                                                        'LDAPMessage': {'members': [{'name': 'messageID',
                                                                                     'optional': False,
                                                                                     'type': 'MessageID'},
                                                                                    {'members': [{'name': 'bindRequest',
                                                                                                  'optional': False,
                                                                                                  'type': 'BindRequest'},
                                                                                                 {'name': 'bindResponse',
                                                                                                  'optional': False,
                                                                                                  'type': 'BindResponse'},
                                                                                                 {'name': 'unbindRequest',
                                                                                                  'optional': False,
                                                                                                  'type': 'UnbindRequest'},
                                                                                                 {'name': 'searchRequest',
                                                                                                  'optional': False,
                                                                                                  'type': 'SearchRequest'},
                                                                                                 {'name': 'searchResEntry',
                                                                                                  'optional': False,
                                                                                                  'type': 'SearchResultEntry'},
                                                                                                 {'name': 'searchResDone',
                                                                                                  'optional': False,
                                                                                                  'type': 'SearchResultDone'},
                                                                                                 {'name': 'searchResRef',
                                                                                                  'optional': False,
                                                                                                  'type': 'SearchResultReference'},
                                                                                                 {'name': 'modifyRequest',
                                                                                                  'optional': False,
                                                                                                  'type': 'ModifyRequest'},
                                                                                                 {'name': 'modifyResponse',
                                                                                                  'optional': False,
                                                                                                  'type': 'ModifyResponse'},
                                                                                                 {'name': 'addRequest',
                                                                                                  'optional': False,
                                                                                                  'type': 'AddRequest'},
                                                                                                 {'name': 'addResponse',
                                                                                                  'optional': False,
                                                                                                  'type': 'AddResponse'},
                                                                                                 {'name': 'delRequest',
                                                                                                  'optional': False,
                                                                                                  'type': 'DelRequest'},
                                                                                                 {'name': 'delResponse',
                                                                                                  'optional': False,
                                                                                                  'type': 'DelResponse'},
                                                                                                 {'name': 'modDNRequest',
                                                                                                  'optional': False,
                                                                                                  'type': 'ModifyDNRequest'},
                                                                                                 {'name': 'modDNResponse',
                                                                                                  'optional': False,
                                                                                                  'type': 'ModifyDNResponse'},
                                                                                                 {'name': 'compareRequest',
                                                                                                  'optional': False,
                                                                                                  'type': 'CompareRequest'},
                                                                                                 {'name': 'compareResponse',
                                                                                                  'optional': False,
                                                                                                  'type': 'CompareResponse'},
                                                                                                 {'name': 'abandonRequest',
                                                                                                  'optional': False,
                                                                                                  'type': 'AbandonRequest'},
                                                                                                 {'name': 'extendedReq',
                                                                                                  'optional': False,
                                                                                                  'type': 'ExtendedRequest'},
                                                                                                 {'name': 'extendedResp',
                                                                                                  'optional': False,
                                                                                                  'type': 'ExtendedResponse'},
                                                                                                 {'name': '...',
                                                                                                  'optional': False,
                                                                                                  'type': ''},
                                                                                                 {'name': 'intermediateResponse',
                                                                                                  'optional': False,
                                                                                                  'type': 'IntermediateResponse'}],
                                                                                     'name': 'protocolOp',
                                                                                     'optional': False,
                                                                                     'type': 'CHOICE'},
                                                                                    {'name': 'controls',
                                                                                     'optional': True,
                                                                                     'tag': {'number': 0},
                                                                                     'type': 'Controls'}],
                                                                        'type': 'SEQUENCE'},
                                                        'LDAPOID': {'size': None,
                                                                    'type': 'OCTET STRING'},
                                                        'LDAPResult': {'members': [{'name': 'resultCode',
                                                                                    'optional': False,
                                                                                    'type': 'ENUMERATED',
                                                                                    'values': {0: 'success',
                                                                                               1: 'operationsError',
                                                                                               2: 'protocolError',
                                                                                               3: 'timeLimitExceeded',
                                                                                               4: 'sizeLimitExceeded',
                                                                                               5: 'compareFalse',
                                                                                               6: 'compareTrue',
                                                                                               7: 'authMethodNotSupported',
                                                                                               8: 'strongerAuthRequired',
                                                                                               10: 'referral',
                                                                                               11: 'adminLimitExceeded',
                                                                                               12: 'unavailableCriticalExtension',
                                                                                               13: 'confidentialityRequired',
                                                                                               14: 'saslBindInProgress',
                                                                                               16: 'noSuchAttribute',
                                                                                               17: 'undefinedAttributeType',
                                                                                               18: 'inappropriateMatching',
                                                                                               19: 'constraintViolation',
                                                                                               20: 'attributeOrValueExists',
                                                                                               21: 'invalidAttributeSyntax',
                                                                                               32: 'noSuchObject',
                                                                                               33: 'aliasProblem',
                                                                                               34: 'invalidDNSyntax',
                                                                                               36: 'aliasDereferencingProblem',
                                                                                               48: 'inappropriateAuthentication',
                                                                                               49: 'invalidCredentials',
                                                                                               50: 'insufficientAccessRights',
                                                                                               51: 'busy',
                                                                                               52: 'unavailable',
                                                                                               53: 'unwillingToPerform',
                                                                                               54: 'loopDetect',
                                                                                               64: 'namingViolation',
                                                                                               65: 'objectClassViolation',
                                                                                               66: 'notAllowedOnNonLeaf',
                                                                                               67: 'notAllowedOnRDN',
                                                                                               68: 'entryAlreadyExists',
                                                                                               69: 'objectClassModsProhibited',
                                                                                               71: 'affectsMultipleDSAs',
                                                                                               80: 'other',
                                                                                               81: '...'}},
                                                                                   {'name': 'matchedDN',
                                                                                    'optional': False,
                                                                                    'type': 'LDAPDN'},
                                                                                   {'name': 'diagnosticMessage',
                                                                                    'optional': False,
                                                                                    'type': 'LDAPString'},
                                                                                   {'name': 'referral',
                                                                                    'optional': True,
                                                                                    'tag': {'number': 3},
                                                                                    'type': 'Referral'}],
                                                                       'type': 'SEQUENCE'},
                                                        'LDAPString': {'size': None,
                                                                       'type': 'OCTET STRING'},
                                                        'MatchingRuleAssertion': {'members': [{'name': 'matchingRule',
                                                                                               'optional': True,
                                                                                               'tag': {'number': 1},
                                                                                               'type': 'MatchingRuleId'},
                                                                                              {'name': 'type',
                                                                                               'optional': True,
                                                                                               'tag': {'number': 2},
                                                                                               'type': 'AttributeDescription'},
                                                                                              {'name': 'matchValue',
                                                                                               'optional': False,
                                                                                               'tag': {'number': 3},
                                                                                               'type': 'AssertionValue'},
                                                                                              {'default': 'FALSE',
                                                                                               'name': 'dnAttributes',
                                                                                               'optional': False,
                                                                                               'tag': {'number': 4},
                                                                                               'type': 'BOOLEAN'}],
                                                                                  'type': 'SEQUENCE'},
                                                        'MatchingRuleId': {'type': 'LDAPString'},
                                                        'MessageID': {'restricted-to': [(0,
                                                                                         'maxInt')],
                                                                      'type': 'INTEGER'},
                                                        'ModifyDNRequest': {'members': [{'name': 'entry',
                                                                                         'optional': False,
                                                                                         'type': 'LDAPDN'},
                                                                                        {'name': 'newrdn',
                                                                                         'optional': False,
                                                                                         'type': 'RelativeLDAPDN'},
                                                                                        {'name': 'deleteoldrdn',
                                                                                         'optional': False,
                                                                                         'type': 'BOOLEAN'},
                                                                                        {'name': 'newSuperior',
                                                                                         'optional': True,
                                                                                         'tag': {'number': 0},
                                                                                         'type': 'LDAPDN'}],
                                                                            'tag': {'class': 'APPLICATION',
                                                                                    'number': 12},
                                                                            'type': 'SEQUENCE'},
                                                        'ModifyDNResponse': {'tag': {'class': 'APPLICATION',
                                                                                     'number': 13},
                                                                             'type': 'LDAPResult'},
                                                        'ModifyRequest': {'members': [{'name': 'object',
                                                                                       'optional': False,
                                                                                       'type': 'LDAPDN'},
                                                                                      {'element': {'members': [{'name': 'operation',
                                                                                                                'optional': False,
                                                                                                                'type': 'ENUMERATED',
                                                                                                                'values': {0: 'add',
                                                                                                                           1: 'delete',
                                                                                                                           2: 'replace',
                                                                                                                           3: '...'}},
                                                                                                               {'name': 'modification',
                                                                                                                'optional': False,
                                                                                                                'type': 'PartialAttribute'}],
                                                                                                   'type': 'SEQUENCE'},
                                                                                       'name': 'changes',
                                                                                       'optional': False,
                                                                                       'size': None,
                                                                                       'type': 'SEQUENCE OF'}],
                                                                          'tag': {'class': 'APPLICATION',
                                                                                  'number': 6},
                                                                          'type': 'SEQUENCE'},
                                                        'ModifyResponse': {'tag': {'class': 'APPLICATION',
                                                                                   'number': 7},
                                                                           'type': 'LDAPResult'},
                                                        'PartialAttribute': {'members': [{'name': 'type',
                                                                                          'optional': False,
                                                                                          'type': 'AttributeDescription'},
                                                                                         {'element': {'type': 'AttributeValue'},
                                                                                          'name': 'vals',
                                                                                          'optional': False,
                                                                                          'size': None,
                                                                                          'type': 'SET OF'}],
                                                                             'type': 'SEQUENCE'},
                                                        'PartialAttributeList': {'element': {'type': 'PartialAttribute'},
                                                                                 'size': None,
                                                                                 'type': 'SEQUENCE OF'},
                                                        'Referral': {'element': {'type': 'URI'},
                                                                     'size': [(1,
                                                                               'MAX')],
                                                                     'type': 'SEQUENCE OF'},
                                                        'RelativeLDAPDN': {'type': 'LDAPString'},
                                                        'SaslCredentials': {'members': [{'name': 'mechanism',
                                                                                         'optional': False,
                                                                                         'type': 'LDAPString'},
                                                                                        {'name': 'credentials',
                                                                                         'optional': True,
                                                                                         'size': None,
                                                                                         'type': 'OCTET STRING'}],
                                                                            'type': 'SEQUENCE'},
                                                        'SearchRequest': {'members': [{'name': 'baseObject',
                                                                                       'optional': False,
                                                                                       'type': 'LDAPDN'},
                                                                                      {'name': 'scope',
                                                                                       'optional': False,
                                                                                       'type': 'ENUMERATED',
                                                                                       'values': {0: 'baseObject',
                                                                                                  1: 'singleLevel',
                                                                                                  2: 'wholeSubtree',
                                                                                                  3: '...'}},
                                                                                      {'name': 'derefAliases',
                                                                                       'optional': False,
                                                                                       'type': 'ENUMERATED',
                                                                                       'values': {0: 'neverDerefAliases',
                                                                                                  1: 'derefInSearching',
                                                                                                  2: 'derefFindingBaseObj',
                                                                                                  3: 'derefAlways'}},
                                                                                      {'name': 'sizeLimit',
                                                                                       'optional': False,
                                                                                       'restricted-to': [(0,
                                                                                                          'maxInt')],
                                                                                       'type': 'INTEGER'},
                                                                                      {'name': 'timeLimit',
                                                                                       'optional': False,
                                                                                       'restricted-to': [(0,
                                                                                                          'maxInt')],
                                                                                       'type': 'INTEGER'},
                                                                                      {'name': 'typesOnly',
                                                                                       'optional': False,
                                                                                       'type': 'BOOLEAN'},
                                                                                      {'name': 'filter',
                                                                                       'optional': False,
                                                                                       'type': 'Filter'},
                                                                                      {'name': 'attributes',
                                                                                       'optional': False,
                                                                                       'type': 'AttributeSelection'}],
                                                                          'tag': {'class': 'APPLICATION',
                                                                                  'number': 3},
                                                                          'type': 'SEQUENCE'},
                                                        'SearchResultDone': {'tag': {'class': 'APPLICATION',
                                                                                     'number': 5},
                                                                             'type': 'LDAPResult'},
                                                        'SearchResultEntry': {'members': [{'name': 'objectName',
                                                                                           'optional': False,
                                                                                           'type': 'LDAPDN'},
                                                                                          {'name': 'attributes',
                                                                                           'optional': False,
                                                                                           'type': 'PartialAttributeList'}],
                                                                              'tag': {'class': 'APPLICATION',
                                                                                      'number': 4},
                                                                              'type': 'SEQUENCE'},
                                                        'SearchResultReference': {'element': {'type': 'URI'},
                                                                                  'size': [(1,
                                                                                            'MAX')],
                                                                                  'tag': {'class': 'APPLICATION',
                                                                                          'number': 19},
                                                                                  'type': 'SEQUENCE OF'},
                                                        'SubstringFilter': {'members': [{'name': 'type',
                                                                                         'optional': False,
                                                                                         'type': 'AttributeDescription'},
                                                                                        {'element': {'members': [{'name': 'initial',
                                                                                                                  'optional': False,
                                                                                                                  'tag': {'number': 0},
                                                                                                                  'type': 'AssertionValue'},
                                                                                                                 {'name': 'any',
                                                                                                                  'optional': False,
                                                                                                                  'tag': {'number': 1},
                                                                                                                  'type': 'AssertionValue'},
                                                                                                                 {'name': 'final',
                                                                                                                  'optional': False,
                                                                                                                  'tag': {'number': 2},
                                                                                                                  'type': 'AssertionValue'}],
                                                                                                     'type': 'CHOICE'},
                                                                                         'name': 'substrings',
                                                                                         'optional': False,
                                                                                         'size': [(1,
                                                                                                   'MAX')],
                                                                                         'type': 'SEQUENCE OF'}],
                                                                            'type': 'SEQUENCE'},
                                                        'URI': {'type': 'LDAPString'},
                                                        'UnbindRequest': {'tag': {'class': 'APPLICATION',
                                                                                  'number': 2},
                                                                          'type': 'NULL'}},
                                              'values': {'maxInt': {'type': 'INTEGER',
                                                                    'value': 2147483647}}}}
